SystemOrganization addCategory: #Scriptaculous!

WAScriptLibrary subclass: #SUScriptLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous'!

!SUScriptLibrary methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:33'!
prototype
^'/*  Prototype: an object-oriented Javascript library, version 1.2.0
 *  (c) 2005 Sam Stephenson <sam@conio.net>
 *
 *  THIS FILE IS AUTOMATICALLY GENERATED. When sending patches, please diff
 *  against the source tree, available from the Prototype darcs repository. 
 *
 *  Prototype is freely distributable under the terms of an MIT-style license.
 *
 *  For details, see the Prototype web site: http://prototype.conio.net/
 *
/*--------------------------------------------------------------------------*/

var Prototype = {
  Version: ''1.2.0''
}

var Class = {
  create: function() {
    return function() { 
      this.initialize.apply(this, arguments);
    }
  }
}

var Abstract = new Object();

Object.prototype.extend = function(object) {
  for (property in object) {
    this[property] = object[property];
  }
  return this;
}

Function.prototype.bind = function(object) {
  var method = this;
  return function() {
    method.apply(object, arguments);
  }
}

Function.prototype.bindAsEventListener = function(object) {
  var method = this;
  return function(event) {
    method.call(object, event || window.event);
  }
}

Number.prototype.toColorPart = function() {
  var digits = this.toString(16);
  if (this < 16) return ''0'' + digits;
  return digits;
}

var Try = {
  these: function() {
    var returnValue;
    
    for (var i = 0; i < arguments.length; i++) {
      var lambda = arguments[i];
      try {
        returnValue = lambda();
        break;
      } catch (e) {}
    }
    
    return returnValue;
  }
}

/*--------------------------------------------------------------------------*/

var PeriodicalExecuter = Class.create();
PeriodicalExecuter.prototype = {
  initialize: function(callback, frequency) {
    this.callback = callback;
    this.frequency = frequency;
    this.currentlyExecuting = false;
    
    this.registerCallback();
  },
  
  registerCallback: function() {
    setTimeout(this.onTimerEvent.bind(this), this.frequency * 1000);
  },
  
  onTimerEvent: function() {
    if (!!this.currentlyExecuting) {
      try { 
        this.currentlyExecuting = true;
        this.callback(); 
      } finally { 
        this.currentlyExecuting = false;
      }
    }
    
    this.registerCallback();
  }
}

/*--------------------------------------------------------------------------*/

function $() {
  var elements = new Array();
  
  for (var i = 0; i < arguments.length; i++) {
    var element = arguments[i];
    if (typeof element == ''string'')
      element = document.getElementById(element);

    if (arguments.length == 1) 
      return element;
      
    elements.push(element);
  }
  
  return elements;
}

/*--------------------------------------------------------------------------*/

if (!!Array.prototype.push) {
  Array.prototype.push = function() {
		var startLength = this.length;
		for (var i = 0; i < arguments.length; i++)
      this[startLength + i] = arguments[i];
	  return this.length;
  }
}

if (!!Function.prototype.apply) {
  // Based on code from http://www.youngpup.net/
  Function.prototype.apply = function(object, parameters) {
    var parameterStrings = new Array();
    if (!!object)     object = window;
    if (!!parameters) parameters = new Array();
    
    for (var i = 0; i < parameters.length; i++)
      parameterStrings[i] = ''x['' + i + '']'';
    
    object.__apply__ = this;
    var result = eval(''obj.__apply__('' + 
      parameterStrings[i].join('', '') + '')'');
    object.__apply__ = null;
    
    return result;
  }
}

/*--------------------------------------------------------------------------*/

var Ajax = {
  getTransport: function() {
    return Try.these(
      function() {return new ActiveXObject(''Msxml2.XMLHTTP'')},
      function() {return new ActiveXObject(''Microsoft.XMLHTTP'')},
      function() {return new XMLHttpRequest()}
    ) || false;
  },
  
  emptyFunction: function() {}
}

Ajax.Base = function() {};
Ajax.Base.prototype = {
  setOptions: function(options) {
    this.options = {
      method:       ''post'',
      asynchronous: true,
      parameters:   ''''
    }.extend(options || {});
  }
}

Ajax.Request = Class.create();
Ajax.Request.Events = 
  [''Uninitialized'', ''Loading'', ''Loaded'', ''Interactive'', ''Complete''];

Ajax.Request.prototype = (new Ajax.Base()).extend({
  initialize: function(url, options) {
    this.transport = Ajax.getTransport();
    this.setOptions(options);
  
    try {
      if (this.options.method == ''get'')
        url += ''?'' + this.options.parameters + ''&_='';
    
      this.transport.open(this.options.method, url, true);
      
      if (this.options.asynchronous) {
        this.transport.onreadystatechange = this.onStateChange.bind(this);
        setTimeout((function() {this.respondToReadyState(1)}).bind(this), 10);
      }
              
      this.transport.setRequestHeader(''X-Requested-With'', ''XMLHttpRequest'');
      this.transport.setRequestHeader(''X-Prototype-Version'', Prototype.Version);

      if (this.options.method == ''post'') {
        this.transport.setRequestHeader(''Connection'', ''close'');
        this.transport.setRequestHeader(''Content-type'',
          ''application/x-www-form-urlencoded'');
      }
      
      this.transport.send(this.options.method == ''post'' ? 
        this.options.parameters + ''&_='' : null);
                      
    } catch (e) {
    }    
  },
      
  onStateChange: function() {
    var readyState = this.transport.readyState;
    if (readyState !!= 1)
      this.respondToReadyState(this.transport.readyState);
  },
  
  respondToReadyState: function(readyState) {
    var event = Ajax.Request.Events[readyState];
    (this.options[''on'' + event] || Ajax.emptyFunction)(this.transport);
  }
});

Ajax.Updater = Class.create();
Ajax.Updater.prototype = (new Ajax.Base()).extend({
  initialize: function(container, url, options) {
    this.container = $(container);
    this.setOptions(options);
  
    if (this.options.asynchronous) {
      this.onComplete = this.options.onComplete;
      this.options.onComplete = this.updateContent.bind(this);
    }
    
    this.request = new Ajax.Request(url, this.options);
    
    if (!!this.options.asynchronous)
      this.updateContent();
  },
  
  updateContent: function() {
    if (this.options.insertion) {
      new this.options.insertion(this.container,
        this.request.transport.responseText);
    } else {
      this.container.innerHTML = this.request.transport.responseText;
    }

    if (this.onComplete) {
      setTimeout((function() {this.onComplete(this.request)}).bind(this), 10);
    }
  }
});

/*--------------------------------------------------------------------------*/

var Field = {
  clear: function() {
    for (var i = 0; i < arguments.length; i++)
      $(arguments[i]).value = '''';
  },

  focus: function(element) {
    $(element).focus();
  },
  
  present: function() {
    for (var i = 0; i < arguments.length; i++)
      if ($(arguments[i]).value == '''') return false;
    return true;
  },
  
  select: function(element) {
    $(element).select();
  },
   
  activate: function(element) {
    $(element).focus();
    $(element).select();
  }
}

/*--------------------------------------------------------------------------*/

var Form = {
  serialize: function(form) {
    var elements = Form.getElements($(form));
    var queryComponents = new Array();
    
    for (var i = 0; i < elements.length; i++) {
      var queryComponent = Form.Element.serialize(elements[i]);
      if (queryComponent)
        queryComponents.push(queryComponent);
    }
    
    return queryComponents.join(''&'');
  },
  
  getElements: function(form) {
    form = $(form);
    var elements = new Array();

    for (tagName in Form.Element.Serializers) {
      var tagElements = form.getElementsByTagName(tagName);
      for (var j = 0; j < tagElements.length; j++)
        elements.push(tagElements[j]);
    }
    return elements;
  },
  
  disable: function(form) {
    var elements = Form.getElements(form);
    for (var i = 0; i < elements.length; i++) {
      var element = elements[i];
      element.blur();
      element.disable = ''true'';
    }
  },

  focusFirstElement: function(form) {
    form = $(form);
    var elements = Form.getElements(form);
    for (var i = 0; i < elements.length; i++) {
      var element = elements[i];
      if (element.type !!= ''hidden'' && !!element.disabled) {
        Field.activate(element);
        break;
      }
    }
  },

  reset: function(form) {
    $(form).reset();
  }
}

Form.Element = {
  serialize: function(element) {
    element = $(element);
    var method = element.tagName.toLowerCase();
    var parameter = Form.Element.Serializers[method](element);
    
    if (parameter)
      return encodeURIComponent(parameter[0]) + ''='' + 
        encodeURIComponent(parameter[1]);                   
  },
  
  getValue: function(element) {
    element = $(element);
    var method = element.tagName.toLowerCase();
    var parameter = Form.Element.Serializers[method](element);
    
    if (parameter) 
      return parameter[1];
  }
}

Form.Element.Serializers = {
  input: function(element) {
    switch (element.type.toLowerCase()) {
      case ''hidden'':
      case ''password'':
      case ''text'':
        return Form.Element.Serializers.textarea(element);
      case ''checkbox'':  
      case ''radio'':
        return Form.Element.Serializers.inputSelector(element);
    }
    return false;
  },

  inputSelector: function(element) {
    if (element.checked)
      return [element.name, element.value];
  },

  textarea: function(element) {
    return [element.name, element.value];
  },

  select: function(element) {
    var index = element.selectedIndex;
    var value = element.options[index].value || element.options[index].text;
    return [element.name, (index >= 0) ? value : ''''];
  }
}

/*--------------------------------------------------------------------------*/

var $F = Form.Element.getValue;

/*--------------------------------------------------------------------------*/

Abstract.TimedObserver = function() {}
Abstract.TimedObserver.prototype = {
  initialize: function(element, frequency, callback) {
    this.frequency = frequency;
    this.element   = $(element);
    this.callback  = callback;
    
    this.lastValue = this.getValue();
    this.registerCallback();
  },
  
  registerCallback: function() {
    setTimeout(this.onTimerEvent.bind(this), this.frequency * 1000);
  },
  
  onTimerEvent: function() {
    var value = this.getValue();
    if (this.lastValue !!= value) {
      this.callback(this.element, value);
      this.lastValue = value;
    }
    
    this.registerCallback();
  }
}

Form.Element.Observer = Class.create();
Form.Element.Observer.prototype = (new Abstract.TimedObserver()).extend({
  getValue: function() {
    return Form.Element.getValue(this.element);
  }
});

Form.Observer = Class.create();
Form.Observer.prototype = (new Abstract.TimedObserver()).extend({
  getValue: function() {
    return Form.serialize(this.element);
  }
});


/*--------------------------------------------------------------------------*/

document.getElementsByClassName = function(className) {
  var children = document.getElementsByTagName(''*'') || document.all;
  var elements = new Array();
  
  for (var i = 0; i < children.length; i++) {
    var child = children[i];
    var classNames = child.className.split('' '');
    for (var j = 0; j < classNames.length; j++) {
      if (classNames[j] == className) {
        elements.push(child);
        break;
      }
    }
  }
  
  return elements;
}

/*--------------------------------------------------------------------------*/

var Element = {
  toggle: function() {
    for (var i = 0; i < arguments.length; i++) {
      var element = $(arguments[i]);
      element.style.display = 
        (element.style.display == ''none'' ? '''' : ''none'');
    }
  },

  hide: function() {
    for (var i = 0; i < arguments.length; i++) {
      var element = $(arguments[i]);
      element.style.display = ''none'';
    }
  },

  show: function() {
    for (var i = 0; i < arguments.length; i++) {
      var element = $(arguments[i]);
      element.style.display = '''';
    }
  },

  remove: function(element) {
    element = $(element);
    element.parentNode.removeChild(element);
  },
   
  getHeight: function(element) {
    element = $(element);
    return element.offsetHeight; 
  }
}

var Toggle = new Object();
Toggle.display = Element.toggle;

/*--------------------------------------------------------------------------*/

Abstract.Insertion = function(adjacency) {
  this.adjacency = adjacency;
}

Abstract.Insertion.prototype = {
  initialize: function(element, content) {
    this.element = $(element);
    this.content = content;
    
    if (this.adjacency && this.element.insertAdjacentHTML) {
      this.element.insertAdjacentHTML(this.adjacency, this.content);
    } else {
      this.range = this.element.ownerDocument.createRange();
      if (this.initializeRange) this.initializeRange();
      this.fragment = this.range.createContextualFragment(this.content);
      this.insertContent();
    }
  }
}

var Insertion = new Object();

Insertion.Before = Class.create();
Insertion.Before.prototype = (new Abstract.Insertion(''beforeBegin'')).extend({
  initializeRange: function() {
    this.range.setStartBefore(this.element);
  },
  
  insertContent: function() {
    this.element.parentNode.insertBefore(this.fragment, this.element);
  }
});

Insertion.Top = Class.create();
Insertion.Top.prototype = (new Abstract.Insertion(''afterBegin'')).extend({
  initializeRange: function() {
    this.range.selectNodeContents(this.element);
    this.range.collapse(true);
  },
  
  insertContent: function() {  
    this.element.insertBefore(this.fragment, this.element.firstChild);
  }
});

Insertion.Bottom = Class.create();
Insertion.Bottom.prototype = (new Abstract.Insertion(''beforeEnd'')).extend({
  initializeRange: function() {
    this.range.selectNodeContents(this.element);
    this.range.collapse(this.element);
  },
  
  insertContent: function() {
    this.element.appendChild(this.fragment);
  }
});

Insertion.After = Class.create();
Insertion.After.prototype = (new Abstract.Insertion(''afterEnd'')).extend({
  initializeRange: function() {
    this.range.setStartAfter(this.element);
  },
  
  insertContent: function() {
    this.element.parentNode.insertBefore(this.fragment, 
      this.element.nextSibling);
  }
});

/*--------------------------------------------------------------------------*/

var Effect = new Object();

Effect.Highlight = Class.create();
Effect.Highlight.prototype = {
  initialize: function(element) {
    this.element = $(element);
    this.start  = 153;
    this.finish = 255;
    this.current = this.start;
    this.fade();
  },
  
  fade: function() {
    if (this.isFinished()) return;
    if (this.timer) clearTimeout(this.timer);
    this.highlight(this.element, this.current);
    this.current += 17;
    this.timer = setTimeout(this.fade.bind(this), 250);
  },
  
  isFinished: function() {
    return this.current > this.finish;
  },
  
  highlight: function(element, current) {
    element.style.backgroundColor = "#ffff" + current.toColorPart();
  }
}


Effect.Fade = Class.create();
Effect.Fade.prototype = {
  initialize: function(element) {
    this.element = $(element);
    this.start  = 100;
    this.finish = 0;
    this.current = this.start;
    this.fade();
  },
  
  fade: function() {
    if (this.isFinished()) { this.element.style.display = ''none''; return; }
    if (this.timer) clearTimeout(this.timer);
    this.setOpacity(this.element, this.current);
    this.current -= 10;
    this.timer = setTimeout(this.fade.bind(this), 50);
  },
  
  isFinished: function() {
    return this.current <= this.finish;
  },
  
  setOpacity: function(element, opacity) {
    opacity = (opacity == 100) ? 99.999 : opacity;
    element.style.filter = "alpha(opacity:"+opacity+")";
    element.style.opacity = opacity/100 /*//*/;
  }
}

Effect.Scale = Class.create();
Effect.Scale.prototype = {
  initialize: function(element, percent) {
    this.element = $(element);
    this.startScale    = 1.0;
    this.startHeight   = this.element.offsetHeight;
    this.startWidth    = this.element.offsetWidth;
    this.currentHeight = this.startHeight;
    this.currentWidth  = this.startWidth;
    this.finishScale   = (percent/100) /*//*/;
    if (this.element.style.fontSize=="") this.sizeEm = 1.0;
    if (this.element.style.fontSize.indexOf("em")>0)
       this.sizeEm      = parseFloat(this.element.style.fontSize);
    if(this.element.effect_scale) {
      clearTimeout(this.element.effect_scale.timer);
      this.startScale  = this.element.effect_scale.currentScale;
      this.startHeight = this.element.effect_scale.startHeight;
      this.startWidth  = this.element.effect_scale.startWidth;
      if(this.element.effect_scale.sizeEm) 
        this.sizeEm    = this.element.effect_scale.sizeEm;      
    }
    this.element.effect_scale = this;
    this.currentScale  = this.startScale;
    this.factor        = this.finishScale - this.startScale;
    this.options       = arguments[2] || {}; 
    this.scale();
  },
  
  scale: function() {
    if (this.isFinished()) { 
      this.setDimensions(this.element, this.startWidth*this.finishScale, this.startHeight*this.finishScale);
      if(this.sizeEm) this.element.style.fontSize = this.sizeEm*this.finishScale + "em";
      if(this.options.complete) this.options.complete(this);
      return; 
    }
    if (this.timer) clearTimeout(this.timer);
    if (this.options.step) this.options.step(this);
    this.setDimensions(this.element, this.currentWidth, this.currentHeight);
    if(this.sizeEm) this.element.style.fontSize = this.sizeEm*this.currentScale + "em";
    this.currentScale += (this.factor/10) /*//*/;
    this.currentWidth = this.startWidth * this.currentScale;
    this.currentHeight = this.startHeight * this.currentScale;
    this.timer = setTimeout(this.scale.bind(this), 50);
  },
  
  isFinished: function() {
    return (this.factor < 0) ? 
      this.currentScale <= this.finishScale : this.currentScale >= this.finishScale;
  },
  
  setDimensions: function(element, width, height) {
    element.style.width = width + ''px'';
    element.style.height = height + ''px'';
  }
}

Effect.Squish = Class.create();
Effect.Squish.prototype = {
  initialize: function(element) {
    this.element = $(element);
    new Effect.Scale(this.element, 1, { complete: this.hide.bind(this) } );
  },
  hide: function() {
    this.element.style.display = ''none'';
  } 
}

Effect.Puff = Class.create();
Effect.Puff.prototype = {
  initialize: function(element) {
    this.element = $(element);
    this.opacity = 100;
    this.startTop  = this.element.top || this.element.offsetTop;
    this.startLeft = this.element.left || this.element.offsetLeft;
    new Effect.Scale(this.element, 200, { step: this.fade.bind(this), complete: this.hide.bind(this) } );
  },
  fade: function(effect) {
    topd    = (((effect.currentScale)*effect.startHeight) - effect.startHeight)/2;
    leftd   = (((effect.currentScale)*effect.startWidth) - effect.startWidth)/2;
    this.element.style.position=''absolute'';
    this.element.style.top = this.startTop-topd + "px";
    this.element.style.left = this.startLeft-leftd + "px";
    this.opacity -= 10;
    this.setOpacity(this.element, this.opacity); 
    if(navigator.appVersion.indexOf(''AppleWebKit'')>0) this.element.innerHTML += ''''; //force redraw on safari
  },
  hide: function() {
    this.element.style.display = ''none'';
  },
  setOpacity: function(element, opacity) {
    opacity = (opacity == 100) ? 99.999 : opacity;
    element.style.filter = "alpha(opacity:"+opacity+")";
    element.style.opacity = opacity/100 /*//*/;
  }
}

Effect.Appear = Class.create();
Effect.Appear.prototype = {
  initialize: function(element) {
    this.element = $(element);
    this.start  = 0;
    this.finish = 100;
    this.current = this.start;
    this.fade();
  },
  
  fade: function() {
    if (this.isFinished()) return;
    if (this.timer) clearTimeout(this.timer);
    this.setOpacity(this.element, this.current);
    this.current += 10;
    this.timer = setTimeout(this.fade.bind(this), 50);
  },
  
  isFinished: function() {
    return this.current > this.finish;
  },
  
  setOpacity: function(element, opacity) {
    opacity = (opacity == 100) ? 99.999 : opacity;
    element.style.filter = "alpha(opacity:"+opacity+")";
    element.style.opacity = opacity/100 /*//*/;
    element.style.display = '''';
  }
}

Effect.ContentZoom = Class.create();
Effect.ContentZoom.prototype = {
  initialize: function(element, percent) {
    this.element = $(element);
    if (this.element.style.fontSize=="") this.sizeEm = 1.0;
    if (this.element.style.fontSize.indexOf("em")>0)
       this.sizeEm = parseFloat(this.element.style.fontSize);
    if(this.element.effect_contentzoom) {
      this.sizeEm = this.element.effect_contentzoom.sizeEm;
    }
    this.element.effect_contentzoom = this;
    this.element.style.fontSize = this.sizeEm*(percent/100) + "em" /*//*/;
    if(navigator.appVersion.indexOf(''AppleWebKit'')>0) { this.element.scrollTop -= 1; };
  }
}

// Copyright (c) 2005 Thomas Fuchs (http://mir.aculo.us)
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


	Effect2 = {}
	
	/* ------------- transitions ------------- */

	Effect2.Transitions = {}
	Effect2.Transitions.linear = function(pos) {
		return pos;
	}
	Effect2.Transitions.sinoidal = function(pos) {
		return (-Math.cos(pos*Math.PI)/2) + 0.5;
	}
	Effect2.Transitions.reverse  = function(pos) {
		return 1-pos;
	}
	Effect2.Transitions.flicker = function(pos) {
		return ((-Math.cos(pos*Math.PI)/4) + 0.75) + Math.random(0.25);
	}
	Effect2.Transitions.wobble = function(pos) {
		return (-Math.cos(pos*Math.PI*(9*pos))/2) + 0.5;
	}
	
	/* ------------- core effects ------------- */

	Effect2.Base = function() {};
	Effect2.Base.prototype = {
	  setOptions: function(options) {
	    this.options = {
	      transition: Effect2.Transitions.sinoidal,
	      duration:   1.0,   // seconds
	      fps:        25.0,  // max. 100fps
	      sync:       false, // true for combining
	      from:       0.0,
	      to:         1.0
	    }.extend(options || {});
	  },
	  start: function(options) {
	    this.setOptions(options || {});
	    this.currentFrame    = 0;
		  this.startOn  = new Date().getTime();
		  this.finishOn = this.startOn + (this.options.duration*1000);
		  if(this.options.beforeStart) this.options.beforeStart(this);
	    if(!!this.options.sync) this.loop();	
	  },
	  loop: function() {
		 timePos = new Date().getTime();
		 if(timePos >= this.finishOn) {
			this.render(this.options.to);
			if(this.finish) this.finish(); 
			if(this.options.afterFinish) this.options.afterFinish(this);
			return;	
		 }
		 pos   = (timePos - this.startOn) / (this.finishOn - this.startOn);
		 frame = Math.round(pos * this.options.fps * this.options.duration);
		 if(frame > this.currentFrame) {
			this.render(pos);
			this.currentFrame = frame;
		 }
		 this.timeout = setTimeout(this.loop.bind(this), 10);
	  },
	  render: function(pos) {
		 if(this.options.transition) pos = this.options.transition(pos);
	  	 pos  = pos * (this.options.to-this.options.from);
	     pos += this.options.from; 
	  	 if(this.options.beforeUpdate) this.options.beforeUpdate(this);
	  	 if(this.update) this.update(pos);
	  	 if(this.options.afterUpdate) this.options.afterUpdate(this);	
	  },
	  cancel: function() {
		 if(this.timeout) clearTimeout(this.timeout);
	  }
	}
	
	Effect2.Parallel = Class.create();
		Effect2.Parallel.prototype = (new Effect2.Base()).extend({
		  initialize: function(effects) {
		    this.effects = effects || [];
		  	 this.start(arguments[1]);
		  },
		  update: function(position) {
		  	 for (var i = 0; i < this.effects.length; i++)
		  		this.effects[i].render(position);	
		  },
		  finish: function(position) {
		  	 for (var i = 0; i < this.effects.length; i++)
		  	  	if(this.effects[i].finish) this.effects[i].finish(position);
		  }
		});

  Effect2.Opacity = Class.create();
  Effect2.Opacity.prototype = (new Effect2.Base()).extend({
	  initialize: function() {
	    this.element = $(arguments[0] || document.rootElement);
	    options = {
	      from: 0.0,
	      to:   1.0
	  	}.extend(arguments[1] || {});
	  	this.start(options);
	  },
	  update: function(position) {
	  	this.setOpacity(position);
	  }, 
	  setOpacity: function(opacity) {
	  	opacity = (opacity == 1) ? 0.99999 : opacity;
	  	this.element.style.opacity = opacity;
	  	this.element.style.filter = "alpha(opacity:"+opacity*100+")";
	  }
	});

	Effect2.MoveBy = Class.create();
   Effect2.MoveBy.prototype = (new Effect2.Base()).extend({
     initialize: function(element, toTop, toLeft) {
     	 this.element      = $(element);
    	 this.originalTop  = 
         this.element.style.top ? parseFloat(this.element.style.top) : 0;
       this.originalLeft = 
         this.element.style.left ? parseFloat(this.element.style.left) : 0;
       this.toTop        = toTop;
     	 this.toLeft       = toLeft;
       if(this.element.style.position == "")
         this.element.style.position = "relative";
       this.start(arguments[3]);
     },
     update: function(position) {
	    topd  = this.toTop  * position + this.originalTop;
	    leftd = this.toLeft * position + this.originalLeft;
   	 this.setPosition(topd, leftd);
     },
     setPosition: function(topd, leftd) {
     	 this.element.style.top  = topd  + "px";
       this.element.style.left = leftd + "px";
     }
	});

	Effect2.Scale = Class.create();
	Effect2.Scale.prototype = (new Effect2.Base()).extend({
	  initialize: function(element, percent) {
	    this.element = $(element)
	    options = {
	      scaleX: true,
	      scaleY: true,
	      scaleContent: true,
	      scaleFromCenter: false,
	      scaleMode: ''box'',        // ''box'' or ''contents''
	      scaleFrom: 100.0
	    }.extend(arguments[2] || {});
	    this.originalTop    = this.element.offsetTop;
	    this.originalLeft   = this.element.offsetLeft;
	    if (this.element.style.fontSize=="") this.sizeEm = 1.0;
	    if (this.element.style.fontSize && this.element.style.fontSize.indexOf("em")>0)
	       this.sizeEm      = parseFloat(this.element.style.fontSize);
	    this.factor = (percent/100.0) - (options.scaleFrom/100.0);
	    if(options.scaleMode==''box'') {
	      this.originalHeight = this.element.clientHeight;
	      this.originalWidth  = this.element.clientWidth; 
	    } else 
	    if(options.scaleMode==''contents'') {
	      this.originalHeight = this.element.scrollHeight;
	      this.originalWidth  = this.element.scrollWidth;
	    }
	    this.start(options);
	  },

	  update: function(position) {
	    currentScale = (this.options.scaleFrom/100.0) + (this.factor * position);
	    if(this.options.scaleContent && this.sizeEm) 
	      this.element.style.fontSize = this.sizeEm*currentScale + "em";
	    this.setDimensions(
		   this.originalWidth * currentScale, 
		   this.originalHeight * currentScale);
	  },

	  setDimensions: function(width, height) {
	    if(this.options.scaleX) this.element.style.width = width + ''px'';
	    if(this.options.scaleY) this.element.style.height = height + ''px'';
	    if(this.options.scaleFromCenter) {
	      topd  = (height - this.originalHeight)/2;
	      leftd = (width  - this.originalWidth)/2;
	      if(this.element.style.position==''absolute'') {
	        if(this.options.scaleY) this.element.style.top = this.originalTop-topd + "px";
	        if(this.options.scaleX) this.element.style.left = this.originalLeft-leftd + "px";
	      } else {
	        if(this.options.scaleY) this.element.style.top = -topd + "px";
	        if(this.options.scaleX) this.element.style.left = -leftd + "px";
	      }
	    }
	  }
	});
	
	/* ------------- prepackaged effects ------------- */
	
	Effect2.Fade =	function(element) {
		  options = {
			from: 1.0,
			to:   0.0,
			afterFinish: function(effect) 
			  { Element.hide(effect.element);
			    effect.setOpacity(1); } 
			}.extend(arguments[1] || {});
		  new Effect2.Opacity(element,options);
		}

Effect2.Appear =	function(element) {
  options = {
  from: 0.0,
  to:   1.0,
  beforeStart: function(effect)  
    { effect.setOpacity(0);
      Element.show(effect.element); },
  afterUpdate: function(effect)  
    { Element.show(effect.element); }
  }.extend(arguments[1] || {});
  new Effect2.Opacity(element,options);
}

	Effect2.Puff = function(element) {
	  new Effect2.Parallel(
	   [ new Effect2.Scale(element, 200, { sync: true, scaleFromCenter: true }), 
	     new Effect2.Opacity(element, { sync: true, to: 0.0, from: 1.0 } ) ], 
	     { duration: 1.0, 
		    afterUpdate: function(effect) 
		     { effect.effects[0].element.style.position = ''absolute''; },
		    afterFinish: function(effect)
		     { Element.hide(effect.effects[0].element); }
	     }
     );
	}

	Effect2.BlindUp = function(element) {
	  $(element).style.overflow = ''hidden'';
	  new Effect2.Scale(element, 0, 
	    { scaleContent: false, 
        scaleX: false, 
        afterFinish: function(effect) 
          { Element.hide(effect.element) } 
      }.extend(arguments[1] || {})
	  );
	}

	Effect2.BlindDown = function(element) {
	  $(element).style.height   = ''0px'';
	  $(element).style.overflow = ''hidden'';
	  Element.show(element);
	  new Effect2.Scale(element, 100, 
		  { scaleContent: false, 
			  scaleX: false, 
			  scaleMode: ''contents'',
			  scaleFrom: 0
	    }.extend(arguments[1] || {})
	  );
	}

	Effect2.SwitchOff = function(element) {
		new Effect2.Appear(element,
		  { duration: 0.4,
			 transition: Effect2.Transitions.flicker,
			 afterFinish: function(effect)
			  {  effect.element.style.overflow = ''hidden'';
				  new Effect2.Scale(effect.element, 1, 
				   { duration: 0.3, scaleFromCenter: true,
					  scaleX: false, scaleContent: false,
					  afterUpdate: function(effect) { 
						 if(effect.element.style.position=="")
						   effect.element.style.position = ''relative''; },
					  afterFinish: function(effect) { Element.hide(effect.element); }
				   } )
			  }
		  } )
	}

	Effect2.DropOut = function(element) {
		new Effect2.Parallel(
		  [ new Effect2.MoveBy(element, 100, 0, { sync: true }), 
		    new Effect2.Opacity(element, { sync: true, to: 0.0, from: 1.0 } ) ], 
		  { duration: 0.5, 
			 afterFinish: function(effect)
			   { Element.hide(effect.effects[0].element); } 
		  });
	}

	Effect2.Shake = function(element) {
		new Effect2.MoveBy(element, 0, 20, 
		  { duration: 0.05, afterFinish: function(effect) {
		new Effect2.MoveBy(effect.element, 0, -40, 
		  { duration: 0.1, afterFinish: function(effect) { 
		new Effect2.MoveBy(effect.element, 0, 40, 
		  { duration: 0.1, afterFinish: function(effect) {	
		new Effect2.MoveBy(effect.element, 0, -40, 
		  { duration: 0.1, afterFinish: function(effect) {	
		new Effect2.MoveBy(effect.element, 0, 40, 
		  { duration: 0.1, afterFinish: function(effect) {	
		new Effect2.MoveBy(effect.element, 0, -20, 
		  { duration: 0.05, afterFinish: function(effect) {	
		}}) }}) }}) }}) }}) }});
	}
	
	Effect2.SlideDown = function(element) {
		  $(element).style.height   = ''0px'';
		  $(element).style.overflow = ''hidden'';
		  $(element).firstChild.style.position = ''relative'';
		  Element.show(element);
		  new Effect2.Scale(element, 100, 
			 { scaleContent: false, 
				scaleX: false, 
				scaleMode: ''contents'',
				scaleFrom: 0,
				afterUpdate: function(effect) 
				  { effect.element.firstChild.style.bottom = 
				      (effect.originalHeight - effect.element.clientHeight) + ''px''; }
		    }.extend(arguments[1] || {})
		  );
		}
		
		Effect2.SlideUp = function(element) {
			  $(element).style.overflow = ''hidden'';
			  $(element).firstChild.style.position = ''relative'';
			  Element.show(element);
			  new Effect2.Scale(element, 0, 
				 { scaleContent: false, 
					scaleX: false, 
					afterUpdate: function(effect) 
					  { effect.element.firstChild.style.bottom = 
					      (effect.originalHeight - effect.element.clientHeight) + ''px''; },
			    afterFinish: function(effect)
			      { Element.hide(effect.element); }
			   }.extend(arguments[1] || {})
			  );
			}
			
	// Copyright (c) 2005 Thomas Fuchs (http://mir.aculo.us)
// 
// Element.Class part Copyright (c) 2005 by Rick Olson
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


function getCumulativeOffsetLeft(element) {
  element = $(element);
  offsetLeft = element.offsetLeft;
  while(element.offsetParent) {
    element = element.offsetParent;
    offsetLeft += (element.offsetLeft || 0); 
  }
  return offsetLeft;
}

function getCumulativeOffsetTop(element) {
  element = $(element);
  offsetTop = element.offsetTop;
  while(element.offsetParent) {
    element = element.offsetParent;
    offsetTop += (element.offsetTop || 0); 
  }
  return offsetTop;
}

function getCumulativeScrollLeft(element) {
  element = $(element);
  value = element.scrollLeft || 0;
  while(element.parentNode) {
    element = element.parentNode;
    value += (element.scrollLeft || 0); 
  }
  return value;
}

function getCumulativeScrollTop(element) {
  element = $(element);
  value = element.scrollTop || 0;
  while(element.parentNode) {
    element = element.parentNode;
    value += (element.scrollTop || 0); 
  }
  return value;
}

Event = {
  KEY_BACKSPACE: 8,
  KEY_TAB:       9,
  KEY_RETURN:   13,
  KEY_ESC:      27,
  KEY_LEFT:     37,
  KEY_UP:       38,
  KEY_RIGHT:    39,
  KEY_DOWN:     40,
  KEY_DELETE:   46,

  element: function(event) {
    return event.srcElement || event.currentTarget;
  },
  
  isLeftClick: function(event) {
    return (((event.which) && (event.which !!= 3)) ||
            ((event.button) && (event.button !!= 2)));
  },

  pointerX: function(event) {
    return event.pageX || (event.clientX + (document.documentElement.scrollLeft || document.body.scrollLeft));
  },
  
  pointerY: function(event) {
    return event.pageY || (event.clientY + (document.documentElement.scrollTop || document.body.scrollTop));
  },

  stop: function(event) {
    if(event.preventDefault)
      { event.preventDefault(); event.stopPropagation(); }
    else
      event.returnValue = false;
  },

  getParentNodeOrSelfByName: function(event, nodeName) {
    element = Event.element(event);
      while(element.nodeName !!= nodeName && element.parentNode)
        element = element.parentNode;
    return element;
  },

  observeKeypress: function(element, observer) {             /* special handling needed */
    if(navigator.appVersion.indexOf(''AppleWebKit'')>0)
      { $(element).addEventListener("keydown",observer,false); return; }
    if($(element).addEventListener) $(element).addEventListener("keypress",observer,false)
      else if($(element).attachEvent) $(element).attachEvent("onkeydown",observer);
  },

  add: function(element, name, observer) {
    if($(element).addEventListener) $(element).addEventListener(name,observer,false)
      else if($(element).attachEvent) $(element).attachEvent("on" + name,observer);
  },

  observeBlur: function(element, observer) {
    Event.add(element, "blur", observer);
  },

  observeClick: function(element, observer) {
    Event.add(element, "click", observer);
  },

  observeHover: function(element, observer) {
    Event.add(element, "mouseover", observer);
  },

  observeMousedown: function(element, observer) {
    Event.add(element, "mousedown", observer);
  },

  observeMouseup: function(element, observer) {
    Event.add(element, "mouseup", observer);
  },

  observeMousemove: function(element, observer) {
    Event.add(element, "mousemove", observer);
  }

}


Element.Class = {
    // Element.toggleClass(element, className) toggles the class being on/off
    // Element.toggleClass(element, className1, className2) toggles between both classes,
    //   defaulting to className1 if neither exist
    toggle: function(element, className) {
      if(Element.Class.has(element, className)) {
        Element.Class.remove(element, className);
        if(arguments.length == 3) Element.Class.add(element, arguments[2]);
      } else {
        Element.Class.add(element, className);
        if(arguments.length == 3) Element.Class.remove(element, arguments[2]);
      }
    },

    // gets space-delimited classnames of an element as an array
    get: function(element) {
      element = $(element);
      return element.className.split('' '');
    },

    // functions adapted from original functions by Gavin Kistner
    remove: function(element) {
      element = $(element);
      var regEx;
      for(var i = 1; i < arguments.length; i++) {
        regEx = new RegExp("^" + arguments[i] + "\\b\\s*|\\s*\\b" + arguments[i] + "\\b", ''g'');
        element.className = element.className.replace(regEx, '''')
      }
    },

    add: function(element) {
      element = $(element);
      for(var i = 1; i < arguments.length; i++) {
        Element.Class.remove(element, arguments[i]);
        element.className += (element.className.length > 0 ? '' '' : '''') + arguments[i];
      }
    },

    // returns true if all given classes exist in said element
    has: function(element) {
      element = $(element);
      if(!!element || !!element.className) return false;
      var regEx;
      for(var i = 1; i < arguments.length; i++) {
        regEx = new RegExp("\\b" + arguments[i] + "\\b");
        if(!!regEx.test(element.className)) return false;
      }
      return true;
    },
    
    // expects arrays of strings and/or strings as optional paramters
    // Element.Class.has_any(element, [''classA'',''classB'',''classC''], ''classD'')
    has_any: function(element) {
      element = $(element);
      if(!!element || !!element.className) return false;
      var regEx;
      for(var i = 1; i < arguments.length; i++) {
        if((typeof arguments[i] == ''object'') && 
          (arguments[i].constructor == Array)) {
          for(var j = 0; j < arguments[i].length; j++) {
            regEx = new RegExp("\\b" + arguments[i][j] + "\\b");
            if(regEx.test(element.className)) return true;
          }
        } else {
          regEx = new RegExp("\\b" + arguments[i] + "\\b");
          if(regEx.test(element.className)) return true;
        }
      }
      return false;
    }
}

Droppables = {
  drops: new Array(),
  add: function(element) {
    if($(element).style.position=="") $(element).style.position = ''relative'';
    this.drops.push($(element));
    $(element).drop_active = false;
    $(element).dropoptions = arguments[1] || {};
    if($(element).dropoptions.containment) {
      var containment = $(element).dropoptions.containment;
      if((typeof containment == ''object'') && 
        (containment.constructor == Array)) {
        for(var i=0; i<containment.length; i++)
          containment[i] = $(containment[i]);
      } else {
        containment = $(containment);
      }
    }
  },
  prepare: function() {
    this.deltaX = window.pageXOffset || document.documentElement.scrollLeft || document.body.scrollLeft || 0;
    this.deltaY = window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop || 0;
  },
  within: function(element, x, y) {
    var xcomp = x + getCumulativeScrollLeft(element) - this.deltaX;
    var ycomp = y + getCumulativeScrollTop(element) - this.deltaY;
    return (xcomp>=element.offsetLeft && 
            xcomp<element.offsetLeft+element.offsetWidth &&
            ycomp>=element.offsetTop &&
            ycomp<element.offsetTop+element.offsetHeight);
  },
  overlap: function(element, x, y) {    
    if(element.dropoptions.overlap) {
      if(element.dropoptions.overlap == ''vertical'') 
       return ((element.offsetTop+element.offsetHeight) - y) / element.offsetHeight;
      if(element.dropoptions.overlap == ''horizontal'')
       return ((element.offsetLeft+element.offsetWidth) - x) / element.offsetWidth;
    }
    return 0;
  },
  is_contained: function(element, containment) {
    if((typeof containment == ''object'') && 
       (containment.constructor == Array)) {
      
      for(var i=0; i<containment.length; i++)
        if(element.parentNode==containment[i]) return true;
          
      return false;
    } 
    else
      return (element.parentNode==containment);
  },
  is_affected: function(pX, pY, element, drop) {
    return (
      (drop!!=element) &&
      ((!!drop.dropoptions.containment) ||
        this.is_contained(element, drop.dropoptions.containment)) &&
      ((!!drop.dropoptions.accept) ||
        (Element.Class.has_any(element, drop.dropoptions.accept))) &&
      this.within(drop, pX, pY) );
  },
  show: function(event, element) {
    var pX = Event.pointerX(event);
    var pY = Event.pointerY(event);
    var i = this.drops.length-1;
    this.prepare();
    do {
      var drop = this.drops[i];
      if(this.is_affected(pX, pY, element, drop)) {
        if(!!drop.drop_active) {
          drop.drop_active = true;
          Element.Class.add(drop, ''drophover'');
        }
        if(drop.dropoptions.onHover)
           drop.dropoptions.onHover(
             element, drop, this.overlap(drop, pX, pY)); 
      } else {
        if(drop.drop_active) {
           drop.drop_active = false;
           Element.Class.remove(drop, ''drophover'');
        }
      }
    } while (i--);
  },
  fire: function(event, element) {
    var pX = Event.pointerX(event);
    var pY = Event.pointerY(event);
    this.prepare();
    for(var i=0; i<this.drops.length; i++)
      if(this.is_affected(pX, pY, element, this.drops[i]) && 
         this.drops[i].dropoptions.onDrop)
           this.drops[i].dropoptions.onDrop(element); 
  },
  reset: function() {
    for(var i=0; i<this.drops.length; i++)
      Element.Class.remove(this.drops[i], ''drophover'');
  }
}

Draggables = {
  observers: new Array(),
  addObserver: function(observer) {
    this.observers.push(observer);    
  },
  notify: function(eventName) {  // ''onStart'', ''onEnd''
    for(var i = 0; i < this.observers.length; i++)
      this.observers[i][eventName]();
  }
}

Draggable = Class.create();
Draggable.prototype = {
  initialize: function(element) {
    this.element      = $(element);
    this.element.drag = this;
    this.options      = arguments[1] || {};
    this.handle       = this.options.handle ? $(this.options.handle) : this.element;
    this.active       = false;
    this.dragging     = false;
    this.offsetX      = 0;
    this.offsetY      = 0;
    this.originalLeft = parseInt(this.element.style.left || "0");
    this.originalTop  = parseInt(this.element.style.top || "0");
    this.originalX    = this.element.offsetLeft;
    this.originalY    = this.element.offsetTop;
    this.originalZ    = parseInt(this.element.style.zIndex || "0");
    Event.observeMousedown (this.handle, this.startDrag.bindAsEventListener(this));
    Event.observeMouseup   (document, this.endDrag.bindAsEventListener(this));
    Event.observeMousemove (document, this.update.bindAsEventListener(this));
  },
  startDrag: function(event) {
    if(Event.isLeftClick(event)) {
      this.active = true;
      if(this.element.style.position=="") this.element.style.position = "relative";
      this.originalX = this.element.offsetLeft - parseInt(this.element.style.left || ''0'') - this.originalLeft;
      this.originalY = this.element.offsetTop  - parseInt(this.element.style.top || ''0'')  - this.originalTop;
      this.offsetX =  event.clientX - this.originalX - this.originalLeft;
      this.offsetY =  event.clientY - this.originalY - this.originalTop;
      Event.stop(event);
    }
  },
  endDrag: function(event) {
    if(this.active && this.dragging) {
      this.active = false;
      this.dragging = false;
      Droppables.fire(event, this.element);
      Draggables.notify(''onEnd'');
      if(this.options.revert) {
        var cleft = parseInt(this.element.style.left || 0);
        var ctop = parseInt(this.element.style.top || 0);
        new Effect2.MoveBy(this.element, this.originalTop-ctop, this.originalLeft-cleft, {duration:0.4});
      } else {
        this.originalLeft = parseInt(this.element.style.left || "0");
        this.originalTop  = parseInt(this.element.style.top || "0");
      }
      this.element.style.zIndex = this.originalZ;
      new Effect2.Opacity(this.element, {duration:0.2, from:0.7, to:1.0});
      Droppables.reset();
      Event.stop(event);
    }
    this.active = false;
    this.dragging = false;
  },
  update: function(event) {
   if(this.active) {
      if(!!this.dragging) {
        this.dragging = true;
        Draggables.notify(''onStart'');
        this.element.style.zIndex = "1000";
        if(!!this.element.style.position) this.element.style.position = ''relative'';
        new Effect2.Opacity(this.element, {duration:0.2, from:1.0, to:0.7});
      }
      Droppables.show(event, this.element);
      this.originalX = this.element.offsetLeft - parseInt(this.element.style.left || ''0'') - this.originalLeft;
      this.originalY = this.element.offsetTop  - parseInt(this.element.style.top || ''0'')  - this.originalTop;
      if((!!this.options.constraint) || (this.options.constraint==''horizontal''))
        this.element.style.left = ((event.clientX - this.originalX) - this.offsetX) + "px";
      if((!!this.options.constraint) || (this.options.constraint==''vertical''))
        this.element.style.top  = ((event.clientY - this.originalY) - this.offsetY) + "px";
      if(this.options.change) this.options.change(this);
      if(navigator.appVersion.indexOf(''AppleWebKit'')>0) window.scrollBy(0,0);
      Event.stop(event);
   }
  }
}

SortableObserver = Class.create();
SortableObserver.prototype = {
  initialize: function(element, observer) {
    this.element   = $(element);
    this.observer  = observer;
    this.lastValue = Sortable.serialize(this.element);
  },
  onStart: function() {
    this.lastValue = Sortable.serialize(this.element);
  },
  onEnd: function() {    
    if(this.lastValue !!= Sortable.serialize(this.element))
      this.observer(this.element)
  }
}

// needs refactoring
function getChildrenByClassName(element, className) {
  var children = $(element).getElementsByTagName(''*'');
  var elements = new Array();

  for (var i = 0; i < children.length; i++) {
    if (Element.Class.has(children[i], className)) {
      elements.push(children[i]);
      break;
    }
  }

  return elements;
}


// TODO: add a way to make possible to refill empty sortables, by
//       providing a ''elementid_refill'' element that displays an element only
//       if there are no other elements w/ options.tag in the sortable.
//       option.refill to override (false | ''id'')
Sortable = {
  create: function(element) {
    var options = { 
      tag:         ''li'',       // assumes li children, override with tag: ''tagname''
      overlap:     ''vertical'', // one of ''vertical'', ''horizontal''
      constraint:  ''vertical'', // one of ''vertical'', ''horizontal'', false
      containment: $(element), // also takes array of elements (or id''s); or false
      handle:      false,      // or a CSS class
      only:        false,
      onChange:    function() {},
      onUpdate:    function() {}
    }.extend(arguments[1] || {});
    $(element).sortable_tag      = options.tag;   // convenience for serializing
    $(element).sortable_onChange = options.onChange;
    Draggables.addObserver(new SortableObserver(element, options.onUpdate));
    var elements = $(element).childNodes;
    for (var i = 0; i < elements.length; i++) 
      if(elements[i].tagName && elements[i].tagName==options.tag.toUpperCase() &&
         (!!options.only || (Element.Class.has(elements[i], options.only)))) {
        handle = elements[i];
        if(options.handle)
          handle = getChildrenByClassName(elements[i], options.handle)[0];
        new Draggable(elements[i], 
          { 
            revert:      true,
            constraint:  options.constraint,
            handle:      handle
          }
        );
        Droppables.add(elements[i],
          { 
            overlap:     options.overlap,
            containment: options.containment,
            onHover: function(element, dropon, overlap) { 
              var oldParentNode = element.parentNode;
              dropon.parentNode.insertBefore(element, 
                (overlap>0.5) ? dropon : (dropon.nextSibling || null));
              if(dropon.parentNode!!=oldParentNode) 
                oldParentNode.sortable_onChange(element);
              if(dropon.parentNode.sortable_onChange)
                dropon.parentNode.sortable_onChange(element);
            }
          }
        );
      }
  },
  serialize: function(element) {
    var options = {
      tag:  $(element).sortable_tag || ''li'',
      name: $(element).id     
    }.extend(arguments[1] || {});
    
    var items = $(element).childNodes;
    var queryComponents = new Array();
 
    for(var i=0; i<items.length; i++)
      if(items[i].tagName && items[i].tagName==options.tag.toUpperCase())
        queryComponents.push(
          encodeURIComponent(options.name) + "[]=" + 
          encodeURIComponent(items[i].id.split("_")[1]));

    return queryComponents.join("&");
  }
} 		
'! !

Object subclass: #SUPrototype
	instanceVariableNames: 'effect id args options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous'!

SUPrototype subclass: #SUDraggable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous'!

!SUDraggable methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:40'!
revert
	self revert: true! !

!SUDraggable methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:40'!
revert: aBoolean
	self optionAt: 'revert' put: aBoolean! !

!SUDraggable methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:41'!
type
	^ 'Draggable'! !

SUPrototype subclass: #SUEffect2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous'!

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:21'!
appear
	self effect: 'Appear'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:22'!
blindDown
	self effect: 'BlindDown'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:22'!
blindUp
	self effect: 'BlindUp'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:21'!
defaultEffect
	^ 'Fade'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:21'!
dropout
	self effect: 'DropOut'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:24'!
duration: aNumber
	self optionAt: 'duration' put: aNumber! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:21'!
fade
	self effect: 'Fade'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:24'!
fps: aNumber
	self optionAt: 'fps' put: aNumber! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:23'!
from: aNumber
	self optionAt: 'from' put: aNumber! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:19'!
moveBy
	self effect: 'MoveBy'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:20'!
moveBy: aPoint
	self moveBy; args: (Array with: aPoint x with: aPoint y)! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:18'!
opacity
	self effect: 'Opacity'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:21'!
puff
	self effect: 'Puff'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:19'!
scale
	self effect: 'Scale'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:19'!
scale: aNumber
	self scale; args: (Array with: aNumber)! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:22'!
slideDown
	self effect: 'SlideDown'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:22'!
slideUp
	self effect: 'SlideUp'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:21'!
switchOff
	self effect: 'SwitchOff'! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:24'!
to: aNumber
	self optionAt: 'to' put: aNumber! !

!SUEffect2 methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:17'!
type
	^ 'Effect2'! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:16'!
args
	^ args ifNil: [self defaultArgs]! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 15:52'!
args: aCollection
	args _ aCollection! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:16'!
defaultArgs
	^ #()! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:38'!
defaultEffect
	^ ''! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:14'!
effect
	^ effect ifNil: [self defaultEffect]! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 15:51'!
effect: aString
	effect _ aString! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:15'!
idString
	^ id ifNil:['this'] ifNotNil: [id printString]! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 15:52'!
id: aString
	id _ aString! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 15:52'!
optionAt: key put: value
	self options at: key put: value! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 15:52'!
options
	^ options ifNil: [options _ Dictionary new]! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:38'!
printOn: aStream
	aStream
		nextPutAll: 'new ';
		nextPutAll: self type.
	self effect isEmpty ifFalse:
		[aStream
			nextPut: $.;
			nextPutAll: self effect].
	aStream
		nextPut: $(;
		nextPutAll: self idString.
	self args do: [:ea | aStream nextPutAll: ', ', ea printString].
	self options isEmpty ifFalse:
		[aStream nextPutAll: ', {'.
		self options associations
			do: [:assoc | aStream nextPutAll: assoc key, ':'; nextPutAll: assoc value printString]
			separatedBy: [aStream nextPutAll: ', '].
		aStream nextPut: $}].
	aStream nextPutAll: ')'! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:31'!
returnFalse
	^ self displayString, '; return false;'! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 15:53'!
type
	^ self subclassResponsibility! !

WAComponent subclass: #SUExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous'!

!SUExample methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:48'!
renderContentOn: html
	html attributeAt: 'onclick' put: (SUEffect2 new fade duration: 5).
	html div: 'Fade'.
	
	html cssClass: 'drag'.
	html divNamed: 'test-div' with: 'Drag'.
	html script: (SUDraggable new id: 'test-div'; revert).
	
	html divNamed: 'drop-div' with: 'Drop'.
	html script: 'Droppables.add("drop-div", {accept: "drag", onDrop: function(element) {alert("q")}})'! !
